package com.knauf.ejb.stateful;
import com.knauf.ejb.stateful.InvalidParameterException;
/**
 * Remote interface for Enterprise Bean: GeometricModelStore
 */
public interface GeometricModelStore extends javax.ejb.EJBObject {
  ///////////////////////////////////////////////////////////////////
  //           Methoden aus Remote-Interface //
  ///////////////////////////////////////////////////////////////////

  /**
   * Hinzufgen eines Satzes von Kantenlngen zur gespeicherten Menge an
   * Berechnungen.
   * 
   * @param a
   *          Kantenlnge von a
   * @param b
   *          Kantenlnge von b
   * @param c
   *          Kantenlnge von c
   * @exception InvalidParameterException
   *              Falls a oder b oder c <= 0 sind.
   */
  public void addCalculation(double a, double b, double c) throws InvalidParameterException, java.rmi.RemoteException;
  /**
   * Alle bisher erfolgten Berechnungen in einen String der Form "Anfrage x:
   * a/b/c" bringen. Als Zeilentrenner dient "\n <br>".
   * 
   * @return String der bisher erfolgten Berechnungen.
   */
  public String getAllCalculations() throws java.rmi.RemoteException;
}