<%@ page import="javax.rmi.PortableRemoteObject, javax.naming.InitialContext, com.knauf.ejb.stateful.*" %>
<HTML>
<HEAD>
<TITLE>
GeometricModelTest
</TITLE>
</HEAD>
<BODY>
<H1>GeometricModel mit Stateful Bean</H1>
<%
InitialContext initialContext = new InitialContext();

//Parameter parsen, falls vorhanden.
GeometricModelStore geometricModelStore = null;
if (request.getParameter("submit") == null)
{
  //Erster Aufruf: Wir erzeugen den Store.

  //Stateful Session Bean holen !
  Object objHomeRef = initialContext.lookup ("java:comp/env/ejb/GeometricModelStore");
  GeometricModelStoreHome geometricModelStoreHome = (GeometricModelStoreHome) PortableRemoteObject.narrow(objHomeRef, GeometricModelStoreHome.class);
  geometricModelStore = geometricModelStoreHome.create();

  //In Session-Context schreiben:
  session.setAttribute("GeometricModelStore", geometricModelStore);
}
else
{
  // Zweiter bis n-ter Aufruf: Berechnen.

  //Den Store aus Session holen:
  geometricModelStore = (GeometricModelStore) session.getAttribute("GeometricModelStore");

  double dblA = Double.parseDouble(request.getParameter("a") );
  double dblB = Double.parseDouble(request.getParameter("b") );
  double dblC = Double.parseDouble(request.getParameter("c") );

  //Zum Store zufgen:
  geometricModelStore.addCalculation( dblA, dblB, dblC);

  ///////////////////////////////////////////////////////////////
  // Berechnung ber Remote-Interface.

  Object homeref = initialContext.lookup ("java:comp/env/ejb/GeometricModel");

  GeometricModelHome home = (GeometricModelHome) PortableRemoteObject.narrow(homeref, GeometricModelHome.class);

  GeometricModel geometricModel = home.create();

  double dblVolume = geometricModel.computeCuboidVolume( dblA, dblB, dblC);
  double dblSurface = geometricModel.computeCuboidSurface( dblA, dblB, dblC);

  %>

  Volumen = <%=dblVolume%>, Oberflche = <%=dblSurface%>
  <br><br><br>

  Ihre letzten Berechnungen: <br>
  <%=geometricModelStore.getAllCalculations() %>
<%
}
%>
<form action="GeometricModelTest.jsp" method="post">
  a = <input type="text" name="a" /> <br>
  b = <input type="text" name="b" /> <br>
  c = <input type="text" name="c" /> <br>

  <input type="submit" name="submit" value="submit" />
</form>

</BODY>
</HTML>
